<template>
  <!-- Main container -->
  <div class="w-full mx-auto py-12 px-4">

    <!-- <h2>{{ $t('circuit.plural') | capitalize }}</h2> -->

    <div v-if="$root.DATA_READY" id="_circuits-container">

      <!-- Circuit item -->
      <div class="_circuit-item-container" v-for="circuit in sortedCircuits" :key="circuit.id">

        <div class="_circuit-item">

          <!-- Top left tag -->
          <div class="_circuit-item-top-tag">
            <HexagonIcon
              width="100%"
              :fill="circuit.color"
            />
            <div class="_circuit-item-top-tag-number _font-zeroes-three">{{ circuit.channel }}</div>
          </div>

          <!-- Top right settings button container -->
          <div
            class="_circuit-item-top-settings"
            data-focused="false"
            @blur="circuitSettingsBlur"
            @focus="circuitSettingsFocus"
          >

            <!-- Button -->
            <div
              class="_circuit-item-top-settings-button"
              tabindex="-1"
              @click="circuitSettingsButtonClick"
              @blur="circuitSettingsButtonBlur"
              @mouseover="circuitSettingsButtonOver"
              @mouseleave="circuitSettingsButtonLeave"
            >
              <!-- Hexagon bg -->
              <HexagonIcon
                width="100%"
                :fill="GLOBALS.__THEME_DARK_3_COLOR__"
                :hover-fill="GLOBALS.__THEME_PRIMARY_COLOR__"
              />
              <!-- Cog icon -->
              <v-icon class="_circuit-item-top-settings-button-icon" name="cog"/>
            </div>

            <!-- "Sub" buttons -->

            <!-- Edit button -->
            <div
              class="_circuit-item-top-settings-subbutton _circuit-item-top-settings-edit-subbutton"
              tabindex="-1"
              @click="(evt) => { openEditCircuitModal(evt, circuit.id) }"
              @mouseover="circuitSettingsButtonOver"
              @mouseleave="circuitSettingsButtonLeave"
            >
              <!-- Hexagon bg -->
              <HexagonIcon
                width="100%"
                :fill="GLOBALS.__THEME_DARK_3_COLOR__"
                :hoverFill="GLOBALS.__THEME_PRIMARY_COLOR__"
              />
              <!-- Edit icon -->
              <v-icon class="_circuit-item-top-settings-button-icon" name="edit"/>
            </div>

            <!-- Delete button -->
            <div
              class="_circuit-item-top-settings-subbutton _circuit-item-top-settings-delete-subbutton"
              tabindex="-1"
              @mouseover="circuitSettingsButtonOver"
              @mouseleave="circuitSettingsButtonLeave"
              @click="(evt) => { openDeleteCircuitModal(evt, circuit.id) }"
            >
              <!-- Hexagon bg -->
              <HexagonIcon
                width="100%"
                :fill="GLOBALS.__THEME_DARK_3_COLOR__"
                :hoverFill="GLOBALS.__THEME_ERROR_COLOR__"
              />
              <!-- Trash icon -->
              <v-icon class="_circuit-item-top-settings-button-icon" name="trash"/>
            </div>

          </div>

          <CircuitIcon
            width="200"
            :fill="circuit.status ? GLOBALS.__THEME_PRIMARY_COLOR__ : GLOBALS.__THEME_DARK_3_COLOR__"
            :status="circuit.status"
            :type="circuit.type"
            class="mx-auto"
          />

          <div class="_circuit-item-name-container">
            <p
              class="_circuit-item-name"
              :style="{
                'border-left': `6px solid ${circuit.color}`,
                'border-right': `6px solid ${circuit.color}`
              }"
            >
                {{ circuit.name }}
            </p>
          </div>

          <Button
            :variant="circuit.status ? 'error' : 'primary'"
            @click.native="turn(circuit.id, !circuit.status)"
            fluid
            class="_font-zeroes-three mx-auto"
            :style="{ 'max-width': '256px' }"
          >
            <v-icon :name="circuit.status ? 'toggle-on' : 'toggle-off'"/>
            {{ circuit.status ? $t('global.off') : $t('global.on') | uppercase }}
          </Button>

        </div>

      </div>

      <!-- New circuit item -->
      <div v-if="availableChannels.length > 0" class="_circuit-new-item-container">

        <div class="_circuit-new-item" @click="openCreateCircuitModal()">

          <HexagonPlusIcon
            width="200"
            :fill="GLOBALS.__THEME_DARK_3_COLOR__"
            class="mx-auto -mt-1"
          />

          <div class="_circuit-new-item-label">
            {{ $t('circuit.addCircuit') | capitalize }}
          </div>

        </div>

      </div>

    </div>

  </div>
</template>

<script>
// vuex
import { mapState, mapGetters, mapActions } from 'vuex'

export default {
  name: 'Dashboard',
  computed: {
    // Map state from 'Circuits' store module
    ...mapState('Circuits', [
      'circuits'
    ]),
    // Map getters from 'Circuits' store module
    ...mapGetters('Circuits', [
      'getCircuit'
    ]),
    /**
     * sortedCircuits
     * @description Sort circuits by channel
     * @return {Circuit[]}
     */
    sortedCircuits: function () {
      const tmp = this.circuits
      tmp.sort(function (a, b) {
        return a.channel - b.channel
      })
      return tmp
    },
    /**
     * availableChannels
     * @description Return available channels
     * @return {number[]}
     */
    availableChannels: function () {
      const defaultChannels = [1, 2, 3, 4]
      const usedChannels = this.circuits.map((circuit) => {
        return circuit.channel
      })
      return defaultChannels.filter((num) => {
        if (!usedChannels.includes(num)) {
          return num
        }
      })
    }
  },
  methods: {
    // Map actions from 'Circuits' store module
    ...mapActions('Circuits', [
      'turnCircuit'
    ]),
    /**
     * Turn circuit on/off
     * @param {number} circuitId - The circuit ID
     * @param {boolean} status - The status
     */
    turn (circuitId, status) {
      this.turnCircuit({
        circuitId: circuitId,
        status: status
      })
    },
    /**
     * When focus event on ._circuit-item-top-settings element
     * @param {Object} evt
     */
    circuitSettingsFocus: function (evt) {
      evt.target.setAttribute('data-focused', true)
    },
    /**
     * When blur event on ._circuit-item-top-settings element
     * @param {Object} evt
     */
    circuitSettingsBlur: function (evt) {
      evt.target.setAttribute('data-focused', false)
    },
    /**
     * When click event on ._circuit-item-top-settings-button element
     * @param {Object} evt
     */
    circuitSettingsButtonClick: function (evt) {
      // Parent (._circuit-item-top-settings)
      const parent = evt.target.parentElement
      // Is focused ?
      const focused = parent.getAttribute('data-focused') === 'true'
      // If focused, dispatch 'blur' event in parent (close)
      if (focused) {
        parent.dispatchEvent(new Event('blur'))
      } else { // else, dispatch 'focus' event in parent (open)
        parent.dispatchEvent(new Event('focus'))
      }
    },
    /**
     * When blur event on ._circuit-item-top-settings-button element
     * @param {Object} evt
     */
    circuitSettingsButtonBlur: function (evt) {
      // Parent (._circuit-item-top-settings)
      const parent = evt.target.parentElement
      // Blurred element
      const blurredElement = evt.relatedTarget
      // If parent does not contain blurred element
      if (!parent.contains(blurredElement)) {
        // Dispatch 'blur' event in parent (close)
        parent.dispatchEvent(new Event('blur'))
      }
    },
    /**
     * When mouseover event on ._circuit-item-top-settings-button element
     * @param {Object} evt
     */
    circuitSettingsButtonOver: function (evt) {
      // Hexagon icon
      const hexagon = evt.target.firstChild
      // Dispatch 'mouseover' event in hexagon
      hexagon.dispatchEvent(new Event('mouseover'))
    },
    /**
     * When mouseleave event on ._circuit-item-top-settings-button element
     * @param {Object} evt
     */
    circuitSettingsButtonLeave: function (evt) {
      // Hexagon icon
      const hexagon = evt.target.firstChild
      // Dispatch 'mouseleave' event in hexagon
      hexagon.dispatchEvent(new Event('mouseleave'))
    },
    /**
     * Handle click on create circuit button.
     * @returns {void}
     */
    openCreateCircuitModal () {
      this.$store.commit('SET_SYSTEM_SHOW_CREATE_CIRCUIT_MODAL', true)
    },
    /**
     * Handle click on circuit edit button.
     * @param {Object} evt
     * @param {number} circuitId - The circuit id
     * @returns {void}
     */
    openEditCircuitModal (evt, circuitId) {
      // Parent (._circuit-item-top-settings)
      const parent = evt.target.parentElement
      parent.dispatchEvent(new Event('blur'))
      this.$store.commit('Circuits/SET_CIRCUIT_TO_EDIT', circuitId)
      this.$store.commit('SET_SYSTEM_SHOW_EDIT_CIRCUIT_MODAL', true)
    },
    /**
     * Handle click on circuit edit button.
     * @param {Object} evt
     * @param {number} circuitId - The circuit id
     * @returns {void}
     */
    openDeleteCircuitModal (evt, circuitId) {
      // Parent (._circuit-item-top-settings)
      const parent = evt.target.parentElement
      parent.dispatchEvent(new Event('blur'))
      this.$store.commit('Circuits/SET_CIRCUIT_TO_DELETE', circuitId)
      this.$store.commit('SET_SYSTEM_SHOW_DELETE_CIRCUIT_MODAL', true)
    }
  }
}
</script>

<style lang="scss">
#_circuits-container {
  @apply flex flex-row flex-wrap;

  ._circuit-item-container {
    @apply w-full sm:w-1/2 lg:max-w-xs; // lg: max 320 px
    @apply p-4;
    @apply mb-4;

    ._circuit-item {
      @apply dark:bg-dark-2;
      @apply rounded-lg;
      @apply pt-4 px-6 pb-6;
      @apply relative;

      ._circuit-item-top-tag {
        @apply absolute;
        @apply left-1;
        width: 82px;
        height: 82px;
        top: -41px;

        ._circuit-item-top-tag-number {
          @apply w-full;
          @apply absolute;
          @apply text-center;
          @apply text-2xl;
          top: 24px;
        }
      }

      ._circuit-item-top-settings {
        @apply transition-all;
        @apply w-auto;
        @apply absolute;
        @apply right-2;
        @apply -top-7;

        ._circuit-item-top-settings-button,
        ._circuit-item-top-settings-subbutton {
          @apply transition-all;
          @apply w-14 h-14;
          @apply cursor-pointer;
          clip-path: path('M28,7.8 46,18 46,38 28,48.4 10.4,38 10.4,18 Z');
        }

        ._circuit-item-top-settings-button {
          * {
            @apply pointer-events-none;
          }

          ._circuit-item-top-settings-button-icon {
            @apply absolute;
            @apply pointer-events-none;
            top: 20px;
            left: 20px;
            opacity: 0.3;
          }

          &:hover {
            ._circuit-item-top-settings-button-icon {
              @apply text-dark-3;
              opacity: 1;
            }
          }
        }

        ._circuit-item-top-settings-subbutton {
          @apply absolute;
          display: none;
          opacity: 0;

          * {
            @apply pointer-events-none;
          }

          &._circuit-item-top-settings-edit-subbutton {
            top: 0;
            left: -42px;

            ._circuit-item-top-settings-button-icon {
              @apply absolute;
              @apply pointer-events-none;
              top: 20px;
              left: 22px;
              opacity: 0.3;
            }
          }

          &._circuit-item-top-settings-delete-subbutton {
            top: 38px;
            left: -21px;

            ._circuit-item-top-settings-button-icon {
              @apply absolute;
              @apply pointer-events-none;
              top: 20px;
              left: 21px;
              opacity: 0.3;
            }
          }

          &._circuit-item-top-settings-edit-subbutton:hover,
          &._circuit-item-top-settings-delete-subbutton:hover {
            ._circuit-item-top-settings-button-icon {
              @apply text-dark-3;
              opacity: 1;
            }
          }
        }

        &[data-focused=true] {
          ._circuit-item-top-settings-subbutton {
            opacity: 1 !important;
            display: block !important;
          }
        }
      }

      ._circuit-item-name-container {
        @apply w-full;
        @apply mb-6;
        @apply text-center;

        ._circuit-item-name {
          @apply inline-block;
          @apply w-auto lg:w-full;
          @apply rounded;
          @apply py-2 px-4;
          @apply text-lg;
          @apply bg-dark-3;
          @apply whitespace-nowrap;
          @apply overflow-ellipsis;
        }
      }
    }
  }

  ._circuit-new-item-container {
    @apply w-full sm:w-1/2 lg:max-w-xs; // lg: max 320 px
    @apply p-4;
    @apply mb-4;

    ._circuit-new-item {
      @apply transition-all;
      @apply border-4 border-dark-2;
      @apply h-full;
      @apply rounded-lg;
      @apply p-4;
      @apply relative;
      @apply cursor-pointer;

      ._circuit-new-item-label {
        @apply transition-all;
        @apply text-xl;
        @apply text-center;
        @apply text-dark-3;
      }

      &:hover {
        @apply bg-dark-2;

        ._circuit-new-item-label {
          @apply text-white;
        }
      }
    }
  }
}
</style>
